// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI64/16AI64_Linux_3.x.x.x_DN/samples/id/perform.c $
// $Rev: 51833 $
// $Date: 2022-10-17 16:04:54 -0500 (Mon, 17 Oct 2022) $

// 16AI64: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _input_modes(void)
{
	gsc_label("Input Modes");
	printf("Differential, Single Ended, Zero Test, +Vref Test\n");
	return(0);
}



//*****************************************************************************
static int _voltage_ranges(void)
{
	gsc_label("Voltage Ranges");
	printf("+-10V, +-5V, +-2.5V\n");
	return(0);
}



//*****************************************************************************
static int _clocking_sources(void)
{
	gsc_label("Clocking Sources");
	printf("Rate Generators, External, Software\n");
	return(0);
}



//*****************************************************************************
static int _sampling_modes(void)
{
	gsc_label("Sampling Modes");
	printf("Continuous, Single Shot\n");
	return(0);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= ai64_reg_list(args->fd, args->detail);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	errs	+= _input_modes();
	errs	+= _voltage_ranges();
	errs	+= _clocking_sources();
	errs	+= _sampling_modes();

	for (i = 0; i < AI64_IOCTL_QUERY_LAST; i++)
		errs	+= ai64_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _register_map(args);
	printf("\n");

	return(errs);
}


