// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI64/16AI64_Linux_3.x.x.x_DN/utils/util_ai_buf_level.c $
// $Rev: 49575 $
// $Date: 2021-07-28 10:46:23 -0500 (Wed, 28 Jul 2021) $

// 16AI64: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai64_ai_buf_level
*
*	Purpose:
*
*		Provide a visual wrapper for the AI64_IOCTL_AI_BUF_LEVEL service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai64_ai_buf_level(int fd, int index, int verbose, s32* get)
{
	char	buf[128];
	int		errs;
	int		ret;
	s32		set			= -1;

	if (verbose)
		gsc_label_index("AI Buffer Level", index);

	ret		= ai64_ioctl(fd, AI64_IOCTL_AI_BUF_LEVEL, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		if (set == -1)
			strcpy(buf, "Feature Not Supported");
		else
			sprintf(buf, "%ld samples", (long) set);

		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", buf);
	}

	if (get)
		get[0]	= set;

	return(errs);
}


