// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AI64/16AI64_Linux_3.x.x.x_DN/utils/util_conv_counter.c $
// $Rev: 42828 $
// $Date: 2018-05-17 16:57:08 -0500 (Thu, 17 May 2018) $

// 16AI64: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai64_conv_counter
*
*	Purpose:
*
*		Provide a visual wrapper for the AI64_IOCTL_CONV_COUNT service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai64_conv_counter(int fd, int index, int verbose, s32 set, s32* get)
{
	char	buf[128];
	int		errs;
	int		ret;

	if (verbose)
		gsc_label_index("Conversion Counter", index);

	ret		= ai64_ioctl(fd, AI64_IOCTL_CONV_COUNT, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		if (set == -1)
			strcpy(buf, "Feature Not Supported");
		else
			sprintf(buf, "%ld conversions", (long) set);

		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", buf);
	}

	if (get)
		get[0]	= set;

	return(errs);
}


